/*++ nqsdeflim.h - Network Queueing System
 *
 * $Source$
 *
 * DESCRIPTION:
 *
 *	Default batch queue resource limits are defined here.
 *
 *
 *	Author:
 *	-------
 *	Robert W. Sandstrom, Sterling Software Incorporated.
 *	February 13, 1986.
 *
 *
 * STANDARDS VIOLATIONS:
 *   None.
 *
 * REVISION HISTORY: ($Revision$ $Date$ $State$)
 * $Log$
 *
 *	April 25, 1991	Quota and cpu time limits for AT&T Unix systems
 *
 */

#if	BSD42 | BSD43 | ULTRIX | SGI | SYS53
#define DLIM_PPCOREUNITS	QLM_MBYTES
#define DLIM_PPCORECOEFF	1L
#else
#if	SYS52 | UNICOS | UTS
#define DLIM_PPCOREUNITS	QLM_BYTES
#define DLIM_PPCORECOEFF	0L
#else
BAD SYSTEM TYPE
#endif
#endif

#if	BSD42 | BSD43 | ULTRIX | SGI | SYS53
#define DLIM_PPDATAUNITS	QLM_MBYTES
#define DLIM_PPDATACOEFF	1L
#else
#if	SYS52 | UNICOS | UTS
#define DLIM_PPDATAUNITS	QLM_BYTES
#define DLIM_PPDATACOEFF	0L
#else
BAD SYSTEM TYPE
#endif
#endif

#if	BSD42 | BSD43 | ULTRIX | SGI | SYS52 | SYS53
#define DLIM_PPPFILEUNITS	QLM_MBYTES
#define DLIM_PPPFILECOEFF	1L
#else
#if	UNICOS
#define DLIM_PPPFILEUNITS	QLM_MBYTES
#define DLIM_PPPFILECOEFF	100L
#else
#if	UTS
#define DLIM_PPPFILEUNITS	QLM_MBYTES
#define DLIM_PPPFILECOEFF	100L
#else
BAD SYSTEM TYPE
#endif
#endif
#endif

#if	BSD42 | BSD43 | ULTRIX | SGI | SYS52 | SYS53 | UNICOS | UTS
#define DLIM_PRPFILEUNITS	QLM_BYTES
#define DLIM_PRPFILECOEFF	0L
#else
BAD SYSTEM TYPE
#endif

#if	BSD42 | BSD43 | ULTRIX | SGI | SYS52 | SYS53 | UNICOS | UTS
#define DLIM_PPQFILEUNITS	QLM_BYTES
#define DLIM_PPQFILECOEFF	0L
#else
BAD SYSTEM TYPE
#endif

#if	BSD42 | BSD43 | ULTRIX | SGI | SYS52 | SYS53 | UNICOS | UTS
#define DLIM_PRQFILEUNITS	QLM_BYTES
#define DLIM_PRQFILECOEFF	0L
#else
BAD SYSTEM TYPE
#endif

#if	BSD42 | BSD43 | ULTRIX | SGI | SYS52 | SYS53 | UNICOS | UTS
#define DLIM_PPTFILEUNITS	QLM_BYTES
#define DLIM_PPTFILECOEFF	0L
#else
BAD SYSTEM TYPE
#endif

#if	BSD42 | BSD43 | ULTRIX | SGI | SYS52 | SYS53 | UNICOS | UTS
#define DLIM_PRTFILEUNITS	QLM_BYTES
#define DLIM_PRTFILECOEFF	0L
#else
BAD SYSTEM TYPE
#endif

#if	UNICOS
#define DLIM_PPMEMUNITS		QLM_MWORDS
#define DLIM_PPMEMCOEFF		256L
#else
#if	BSD42 | BSD43 | ULTRIX | SGI | SYS52 | SYS53 | UTS
#define DLIM_PPMEMUNITS		QLM_BYTES
#define DLIM_PPMEMCOEFF		0L
#else
BAD SYSTEM TYPE
#endif
#endif

#if	UNICOS
#define DLIM_PRMEMUNITS		QLM_MWORDS
#define DLIM_PRMEMCOEFF		256L
#else
#if	BSD42 | BSD43 | ULTRIX | SGI | SYS52 | SYS53 | UTS
#define DLIM_PRMEMUNITS		QLM_BYTES
#define DLIM_PRMEMCOEFF		0L
#else
BAD SYSTEM TYPE
#endif
#endif

#if	BSD42 | BSD43 | ULTRIX | SGI | SYS53
#define DLIM_PPSTACKUNITS	QLM_MBYTES
#define DLIM_PPSTACKCOEFF	1L
#else
#if	SYS52 | UNICOS | UTS
#define DLIM_PPSTACKUNITS	QLM_BYTES
#define DLIM_PPSTACKCOEFF	0L
#else
BAD SYSTEM TYPE
#endif
#endif

#if	BSD42 | BSD43 | ULTRIX | SGI | SYS53
#define DLIM_PPWORKUNITS	QLM_MBYTES
#define DLIM_PPWORKCOEFF	1L
#else
#if	SYS52 | UNICOS | UTS
#define DLIM_PPWORKUNITS	QLM_BYTES
#define DLIM_PPWORKCOEFF	0L
#else
BAD SYSTEM TYPE
#endif
#endif

#if	BSD42 | BSD43 | ULTRIX | SGI | SYS53
#define DLIM_PPCPUSECS		36000
#define DLIM_PPCPUMS		0
#else
#if	UNICOS
#define DLIM_PPCPUSECS		720000
#define DLIM_PPCPUMS		0
#else
#if	SYS52 | UTS
#define DLIM_PPCPUSECS		0
#define DLIM_PPCPUMS		0
#else
BAD SYSTEM TYPE
#endif
#endif
#endif

#if	UNICOS
#define DLIM_PRCPUSECS		720000
#define DLIM_PRCPUMS		0
#else
#if	BSD42 | BSD43 | ULTRIX | SGI | SYS52 | SYS53 | UTS
#define DLIM_PRCPUSECS		0
#define DLIM_PRCPUMS		0
#else
BAD SYSTEM TYPE
#endif
#endif

#if	BSD42 | BSD43 | ULTRIX | SGI | SYS52 | SYS53 | UNICOS | UTS
#define DLIM_PPNICE		0
#else
BAD SYSTEM TYPE
#endif

#if	BSD42 | BSD43 | ULTRIX | SGI | SYS52 | SYS53 | UNICOS | UTS
#define DLIM_PRDRIVES		0
#else
BAD SYSTEM TYPE
#endif

#if	BSD42 | BSD43 | ULTRIX | SGI | SYS52 | SYS53 | UNICOS | UTS
#define DLIM_PRNCPUS		0
#else
BAD SYSTEM TYPE
#endif

