/*++ quolim.h - Network Queueing System
 *
 * $Source$
 *
 * DESCRIPTION:
 *
 *
 *	Quota structure definitions file.
 *
 *
 *	Author:
 *	-------
 *	Brent A. Kingsbury, Sterling Software Incorporated.
 *	August 12, 1985.
 *
 *
 * STANDARDS VIOLATIONS:
 *   None.
 *
 * REVISION HISTORY: ($Revision$ $Date$ $State$)
 * $Log$
 *
 */

/*
 *	Quota limit units:
 */
#define	QLM_BYTES	011	/* Resource limit in bytes */
#define	QLM_WORDS	012	/* Resource limit in words */
#define	QLM_KBYTES	021	/* Resource limit in kilobytes */
#define	QLM_KWORDS	022	/* Resource limit in kilowords */
#define	QLM_MBYTES	031	/* Resource limit in megabytes */
#define	QLM_MWORDS	032	/* Resource limit in megawords */
#define	QLM_GBYTES	041	/* Resource limit in gigabytes */
#define	QLM_GWORDS	042	/* resource limit in gigawords */


/*
 *	Quota structures:
 */
struct cpulimit {
	unsigned long max_seconds;	/* Maximum CPU time in seconds */
	unsigned long warn_seconds;	/* Warning CPU time in seconds */
	short max_ms;			/* + max_ms (milliseconds) */
	short warn_ms;			/* + warn_ms (milliseconds) */
};


struct quotalimit {
	unsigned long max_quota;	/* Max quota limit measured in */
	unsigned long warn_quota;	/* Warn quota limit measured in */
	short max_units;		/* units of type: max_units */
	short warn_units;		/* units of type: warn_units */
};
