/*++ bufstderr.c - Network Queueing System
 *
 * $Source$
 *
 * DESCRIPTION:
 *
 *	Block buffer the output to the stderr file stream.
 *
 *
 *	Author:
 *	-------
 *	Brent A. Kingsbury, Sterling Software Incorporated.
 *	October 27, 1985.
 *
 *
 * STANDARDS VIOLATIONS:
 *   None.
 *
 * REVISION HISTORY: ($Revision$ $Date$ $State$)
 * $Log$
 *
 */

#include <stdio.h>


/*** bufstderr
 *
 *
 *	void bufstderr():
 *	Block buffer the output to the stderr file stream.
 */
void bufstderr()
{
	static char stderr_buffer [BUFSIZ];	/* Stderr output buffer */

#if	BSD42 | BSD43 | ULTRIX
	setbuffer (stderr, stderr_buffer, BUFSIZ);
#else
#if	UNICOS | SGI | SYS52 | SYS53 | UTS
	/*
	 *  Set the stderr stream to be block buffered.
	 */
	setvbuf (stderr, stderr_buffer, _IOFBF, BUFSIZ);
#else
BAD SYSTEM TYPE
#endif
#endif
}
