/*++ bufstdout.c - Network Queueing System
 *
 * $Source$
 *
 * DESCRIPTION:
 *
 *	Block buffer the output to the stdout file stream.
 *
 *
 *	Author:
 *	-------
 *	Brent A. Kingsbury, Sterling Software Incorporated.
 *	October 27, 1985.
 *
 *
 * STANDARDS VIOLATIONS:
 *   None.
 *
 * REVISION HISTORY: ($Revision$ $Date$ $State$)
 * $Log$
 *
 */

#include <stdio.h>


/*** bufstdout
 *
 *
 *	void bufstdout():
 *	Block buffer the output to the stdout file stream.
 */
void bufstdout()
{
	static char stdout_buffer [BUFSIZ];	/* Stdout output buffer */

#if	BSD42 | BSD43 | ULTRIX
	setbuffer (stdout, stdout_buffer, BUFSIZ);
#else
#if	UNICOS | SGI | SYS52 | SYS53 | UTS
	/*
	 *  Set the stdout stream to be block buffered.
	 */
	setvbuf (stdout, stdout_buffer, _IOFBF, BUFSIZ);
#else
BAD SYSTEM TYPE
#endif
#endif
}
