/*++ fmttime.c - Network Queueing System
 *
 * $Source$
 *
 * DESCRIPTION:
 *
 *	Format a time string.
 *
 *
 *	Author:
 *	-------
 *	Brent A. Kingsbury, Sterling Software Incorporated.
 *	August 12, 1985.
 *
 *
 * STANDARDS VIOLATIONS:
 *   None.
 *
 * REVISION HISTORY: ($Revision$ $Date$ $State$)
 * $Log$
 *
 */
#ifdef	DOMAIN_OS
/*
 * This is to use explicitly the BSD 'timezone()' function with the new ANSI
 * C compiler on DOMAIN_OS (version 6.8), because the name 'timezone' refers
 * to a data location as specified by System V.
 */
#define timezone _bky_timezone
#endif
#include <sys/types.h>			/* time_t */
#if	SGI | SYS52 | SYS53 | UTS | UNICOS
#include <time.h>
#else
#if	BSD42 | BSD43 | ULTRIX
#ifdef	_AIX
/*
 * Structure returned by gmttime and localtime calls (see ctime(3)),
 * not defined in the AIX BSD environment.
 */
struct	tm {
	int	tm_sec;
	int	tm_min;
	int	tm_hour;
	int	tm_mday;
	int	tm_mon;
	int	tm_year;
	int	tm_wday;
	int	tm_yday;
	int	tm_isdst;
};
#endif
#include <sys/time.h>
extern char *timezone();
#else
BAD SYSTEM TYPE
#endif
#endif

extern struct tm *localtime ();		/* Get local time */
extern char *asctime();			/* Format time */

/*** fmttime
 *
 *
 *	char *fmttime():
 *
 *	Return a pointer to a formatted time string where the time
 *	is specified as a long integer defining the number of seconds
 *	since 00:00:00 GMT, January 1, 1970.
 */
char *fmttime (timeinsecs)
time_t *timeinsecs;
{
	static char buffer [40];	/* Output buffer */
	char *tzn;			/* Time zone name */
	char *ts;			/* Time string */
	struct tm *tp;			/* Time structure pointer */

#if	SGI | SYS52 | SYS53 | UTS | UNICOS
	tzset();			/* Get local timezone */
	tp = localtime (timeinsecs);
	ts = asctime (tp);
	tzn = tzname [tp->tm_isdst];
#else
#if	BSD42 | BSD43 | ULTRIX
	struct	timeval	tv;
	struct	timezone tz;

	gettimeofday (&tv, &tz);
	tp = localtime (timeinsecs);
	ts = asctime (tp);
	tzn = timezone (tz.tz_minuteswest, tp->tm_isdst);
#else
BAD SYSTEM TYPE
#endif
#endif
	if (tzn == (char *) 0) tzn = "";
	ts [24] = '\0';				/* Zap newline character */
	sprintf (buffer, "%.20s%s%s", ts, tzn, ts+19);
	return (buffer);
}
