/*++ fsizedb.c - Network Queueing System
 *
 * $Source$
 *
 * DESCRIPTION:
 *
 *	Update the current size of the specified database file.
 *
 *
 *	Author:
 *	-------
 *	Brent A. Kingsbury, Sterling Software Incorporated.
 *	August 12, 1985.
 *
 *
 * STANDARDS VIOLATIONS:
 *   None.
 *
 * REVISION HISTORY: ($Revision$ $Date$ $State$)
 * $Log$
 *
 */
#include "nqs.h"

extern long lseek();
extern void seekdb();			/* Unbuffered seek on an NQS */
					/* database file */

/*** fsizedb
 *
 *
 *	void fsizedb():
 *	Update the current size of the specified NQS database file.
 */
void fsizedb (file)
register struct confd *file;
{
	register long filesize;

	filesize = lseek (file->fd, 0L, 2);
	/*
	 *  Seek back to the original position (also reloading the
	 *  contents of the cache buffer, since the cache block could
	 *  be out of date)!!!!
	 */
	file->size = filesize;		/* Update size */
	seekdb (file, file->vposition);	/* Restore file position and */
					/* reload cache block */
}
