/*++ hdlreq.c - Network Queueing System
 *
 * $Source$
 *
 * DESCRIPTION:
 *
 *	Handle (hold or release) a NQS request.
 *
 *
 *	Author:
 *	-------
 *	Christian Boissat, CERN, Geneva, Switzerland.
 *	January 6, 1992.
 *
 *
 * STANDARDS VIOLATIONS:
 *   None.
 *
 * REVISION HISTORY: ($Revision$ $Date$ $State$)
 * $Log$
 *
 */

#include "nqspacket.h"			/* NQS local message packets */
#if	BSD43 | SGI | SYS52 | SYS53 | ULTRIX
#include <sys/types.h>			/* Uid_t, gid_t */
#else
#if	BSD42 | UNICOS | UTS
#else
BAD SYSTEM TYPE
#endif
#endif
#include NMAP				/* Mid_t (all OS's) */
					/* Uid_t and gid_t (if not BSD43) */

extern long inter();			/* Send local packet */
extern void interclear();		/* Clear packet */
extern void interw32i();		/* Write packet integer datum */

/*** hdlreq
 *
 *
 *	long hdlreq():
 *
 *	Send to the NQS daemon a packet which will hold or release a
 *	request.
 *
 *	Returns:
 *		TCML_COMPLETE:	 if successful;
 *		TCML_NOSUCHREQ:	 if request does not exist.
 *		TCML_REQRUNNING: if the request is running, and has
 *				 not been signalled.
 */
long hdlreq (oper, whomuid, req_seqno, req_mid)
int oper;			/* Type of operation (hold or release) */
uid_t whomuid;			/* Calling user, else zero for */
				/* NQS operator/manager call  */
int req_seqno;			/* Request sequence number */
mid_t req_mid;			/* Request machine id */
{
	interclear();
	interw32i ((long) whomuid);
	interw32i ((long) req_seqno);
	interw32i ((long) req_mid);
	return (inter (oper == 0 ? PKT_HOLDREQ : PKT_RELREQ));
}
