#include <stdio.h>
#include <ctype.h>
#include "nqs.h"		/* NQS definitions */
/* #include "netpacket.h"			NQS networking */
#include <pwd.h>			/* Password stuff */

#if	BSD42 | BSD43 | ULTRIX | UTS
#include <sys/file.h>			/* file stuff */
#else
#if	SYS52 | SYS53 | SGI | UNICOS  
#include <sys/fcntl.h>			/* file stuff */
#else
BAD SYSTEM TYPE
#endif
#endif

#if	UNICOS
#include "scpnqs.h"
#include <sys/param.h>
#include <sys/jtab.h>
#include <signal.h>
#include <sys/user.h>
#include <sys/sysmacros.h>
#else
#if	BSD42 | BSD43 | SGI | SYS52 | SYS53 | ULTRIX | UTS
#else
BAD SYSTEM TYPE
#endif
#endif
#include "nqsxdirs.h"		/*  NQS directories */
#include "nqsxvars.h"		/* NQS directories */


/*
 *	External functions.
 */
extern int gethostname();               /* Get host name */
extern char *getmacname();               /* Get machine name */
extern char *destqueue();               /* Strip "@machine" */
extern struct passwd *fetchpwuid();	/* NQS version of getpwuid */
extern long filecopyentire();		/* File descr to file descr copy */
extern void interclear();		/* Zero out inter() structs */
extern void interw32i();		/* Write a 32 bit integer */
extern void interwstr();		/* Write a string */
extern int localmid();			/* Get our mid */
extern void nqssleep();			/* NQS version of sleep() */
extern int seekdb();			/* Seek on a db file */
extern char *strncpy();			/* Anchored string copy */
extern void analyzetcm();		/* Print message */
extern char *bufsockch();		/* Ptr to extra chars from socket */
extern int  daepres();		/* is local NQS daemon present & running */
extern char *destqueue();		/* Strip "@machine" */
extern int establish();			/* Set up connection */
extern int extrasockch();		/* Number of extra chars from socket */
extern char *fmttime();		/* Format time long integer to local time */
				/* string */
extern char *getgrpnam();	/* Get group name given gid */
extern char *getmacnam();	/* Get machine name from machine-id */
extern int getrreq();		/* Get a control file request header */
extern uid_t getuid();		/* Get real user-id */
extern char *getusenam();	/* Get user name for user-id */
extern long lseek();		/* Seek on a file */
extern struct gendescr *nextdb();	/* Return next allocated entry */
extern struct confd *opendb();	/* Open an NQS database file */
extern int openqacc();		/* Open a queue access file */
extern int openqord();		/* Open a queue ordering file */
extern void seekdbb();		/* Buffered seek on an NQS database file */
extern int strlen();		/* String length */
extern int strcmp();		/* String comparison */
extern int strncmp();		/* Anchored string comparison */
extern long telldb();		/* Return position of last read on an NQS */
				/* database file */
extern void dsp_q();		/* Show a queue given by name */


/*** listr
 *
 * Read the requests and
 * send to correct display
 * (short or long format).
 */
int listr (file, que_descr, flags, selector,req,daemon)
register struct confd *file;			/* NQS queue file */
register struct gendescr *que_descr;		/* the queue descriptor */
register long flags;				/* Display flags */
register char * selector;
register char * req;
register short daemon;
{

	struct qentry cache [QOFILE_CACHESIZ];
	struct rawreq	request;
	int cacheindex = 0;		/* Current buffer cache index */
	int fd;				/* Queue ordering file descriptor */
	int i;				/* Loop var */
	int count;
	int cfd;
	short daepresent;
 
	if (!daemon) {
		que_descr->v.que.queuedcount += 
			que_descr->v.que.runcount;
		que_descr->v.que.runcount = 0;
	}

	/* step 2. Open the request queue ordering file.  
	 *  fd >= 0 if the queue has requests, and we successfully
	 *	    opened the queue ordering file.
	 *  fd = -1 if the queue has no requests.
	 *  fd = -2 if the queue has requests, but an error prevented
	 *	    us from opening the queue ordering file for
	 *	    the queue.
	 *  fd = -3 if the queue was deleted.
	 */
	fd = openqord (file, que_descr);
	if (fd < -1) return (fd);	/* Error or queue was deleted */

	/* step 3. Departing Requests display, if all or in transit is requested*/
	if  (flags & SHO_RS_EXIT )
	  if ( (count = que_descr->v.que.departcount) != 0) {
           read(fd,(char *) cache, sizeof (cache));
	   for(i=0; i<count; i++) {
                if ((cfd = getrreq(cache[cacheindex+i].orig_seqno, cache
                        [cacheindex+i].orig_mid, &request)) != -1) {
				if (flags & SHO_FULL){
					full_listr(&request,que_descr,SHO_RS_EXIT,flags,
						selector,req,(long)0);
				}
				else {
	                                dsp_req(que_descr,flags, 
						SHO_RS_EXIT,&request, selector,req);
				}
				close(cfd);
		}
           }
          }
        cacheindex += que_descr->v.que.departcount;

	/* step 4. Running Requests display, if all or running is requested*/
	if (flags & SHO_RS_RUN )	
	  if ( (count = que_descr->v.que.runcount) != 0) {
           read(fd,(char *) cache, sizeof (cache));
	   for(i=0; i<count; i++) {
                if ((cfd = getrreq(cache[cacheindex+i].orig_seqno, cache
                        [cacheindex+i].orig_mid, &request)) != -1) {
				if (flags & SHO_FULL){
					full_listr(&request,que_descr,SHO_RS_RUN,flags,
						selector,req,cache
						[cacheindex+i].v.process_family);
				}
				else {
	                                dsp_req(que_descr,flags, 
						SHO_RS_RUN,&request, selector,req);
				}
				close(cfd);
		}
           }
          }
        cacheindex += que_descr->v.que.runcount;

	/* step 5. Staged Requests display, if all or in transit is requested*/

	if (flags & SHO_RS_EXIT )
	  if ( (count = que_descr->v.que.stagecount) != 0) {
           read(fd,(char *) cache, sizeof (cache));
	   for(i=0; i<count; i++) {
                if ((cfd = getrreq(cache[cacheindex+i].orig_seqno, cache
                        [cacheindex+i].orig_mid, &request)) != -1) {
				if (flags & SHO_FULL){
					full_listr(&request,que_descr,SHO_RS_STAGE,flags,
						selector,req,(long)0);
				}
				else {
	                                dsp_req(que_descr,flags, 
						SHO_RS_STAGE,&request, selector,req);
				}
				close(cfd);
		}
           }
          }
        cacheindex += que_descr->v.que.stagecount;

	/* step 6. Queued Requests display, if all or queued is requested*/

	if (flags & SHO_RS_QUEUED )
	  if ( (count = que_descr->v.que.queuedcount) != 0) {
           read(fd,(char *) cache, sizeof (cache));
	   for(i=0; i<count; i++) {
                if ((cfd = getrreq(cache[cacheindex+i].orig_seqno, cache
                        [cacheindex+i].orig_mid, &request)) != -1) {
				if (flags & SHO_FULL){
					full_listr(&request,que_descr,SHO_RS_QUEUED,flags,
						selector,req,(long)0);
				}
				else {
	                                dsp_req(que_descr,flags, 
						SHO_RS_QUEUED,&request, selector,req);
				}
				close(cfd);
		}
           }
          }
        cacheindex += que_descr->v.que.queuedcount;

	/* step 7. Waiting Requests display, if all or held is requested*/

	if (flags & SHO_RS_HOLD )
	  if ( (count = que_descr->v.que.waitcount) != 0) {
           read(fd,(char *) cache, sizeof (cache));
	   for(i=0; i<count; i++) {
                if ((cfd = getrreq(cache[cacheindex+i].orig_seqno, cache
                        [cacheindex+i].orig_mid, &request)) != -1) {
				if (flags & SHO_FULL){
					full_listr(&request,que_descr,SHO_RS_WAIT,flags,
						selector,req,(long)0);
				}
				else {
	                                dsp_req(que_descr,flags, 
						SHO_RS_WAIT,&request, selector,req);
				}
				close(cfd);
		}
           }
          }
        cacheindex += que_descr->v.que.waitcount;
          
	/* step 8. Holding Requests display, if all or held is requested*/

	if (flags & SHO_RS_HOLD )
	  if ( (count = que_descr->v.que.holdcount) != 0) {
           read(fd,(char *) cache, sizeof (cache));
	   for(i=0; i<count; i++) {
                if ((cfd = getrreq(cache[cacheindex+i].orig_seqno, cache
                        [cacheindex+i].orig_mid, &request)) != -1) {
				if (flags & SHO_FULL){
					full_listr(&request,que_descr,SHO_RS_HOLD,flags,
						selector,req,(long)0);
				}
				else {
	                                dsp_req(que_descr,flags, 
						SHO_RS_HOLD,&request, selector,req);
				}
				close(cfd);
		}
           }
          }
        cacheindex += que_descr->v.que.holdcount;
          
	/* step 9. Arriving Requests display, if all or in transit is requested*/

	if (flags & SHO_RS_EXIT )
	  if ( (count = que_descr->v.que.arrivecount) != 0) {
           read(fd,(char *) cache, sizeof (cache));
	   for(i=0; i<count; i++) {
                if ((cfd = getrreq(cache[cacheindex+i].orig_seqno, cache
                        [cacheindex+i].orig_mid, &request)) != -1) {
				if (flags & SHO_FULL){
					full_listr(&request,que_descr,SHO_RS_ARRIVE,flags,
						selector,req,(long)0);
				}
				else {
	                                dsp_req(que_descr,flags, 
						SHO_RS_ARRIVE,&request, selector,req);
				}
				close(cfd);
		}
           }
          }
        /* cacheindex += que_descr->v.que.arrivecount; */
          
	/* step 10. close queue ording file and return */
	close (fd);			
	return (0);			
}


/*** get_rstate
 *
 * get state of request by queue typed
 * and state
 */
static char *get_rstate(type, state)
short   type;
long    state;
{


 /* determine the state of the request 
  * according to queue type and request 
  */

 switch (state) {
         case SHO_RS_EXIT:
                if (type == QUE_BATCH) {
                        return(  "EXITING");
                }
                else if (type == QUE_PIPE) {
                        return("DEPARTING");
                }
                else return("UNKNOWN");
        case SHO_RS_RUN:
                if (type == QUE_PIPE)
                        return("ROUTING");
                else
                        return("RUNNING");
        case SHO_RS_STAGE:
                if (type == QUE_BATCH) {
                return("STAGING");
                }
                else return("UNKNOWN");
        case SHO_RS_QUEUED:
                return("QUEUED");
        case SHO_RS_WAIT:
                return("WAITING");
        case SHO_RS_HOLD:
                return("HOLDING");
        case SHO_RS_ARRIVE:
                return("ARRIVING");
        default:
                return("UNKNOWN");     /* We should never get here */
                }

}

 
/*** dsp_req
 *
 * display request, short form
 */
dsp_req(queue,flags,state,req,selector,def_req)
	struct gendescr *queue;		/* the queue descriptor */
	long	flags;
        long    state;
        struct  rawreq  *req;
	char 	* selector;
	char 	* def_req;
{
	char 	mac[11];
        int     cnt;
        char    *mach;
        char    status[8];
	long	val;
	char 	*machinename;

	/* if not all validate whom to see */
	if (!(flags & SHO_R_ALLUID)) {
		if (def_req != NULL) {
			val=0;
			while (*def_req >= '0' && *def_req <='9'){
				val *=10;
				val += *def_req -'0';
				def_req++;
			}
			if (val !=req->orig_seqno) 
				return(0);
			
				/* if (adm) */
		}
		else {
			if (val_user(selector,req->username)== -1)
				return (0);
			}
	}


	/* get originating machine */
	machinename=getmacnam(req->orig_mid);
	strncpy(mac,machinename,8);
	mac[8]='\0';


	printf("%5d.%-7.7s %-15.15s %-11.11s %-11.11s %-3d  %-3d",
	req->orig_seqno,		/* print request id */
	mac,				/* print originating machine */
        req->reqname,			/* print request name */
        req->username,			/* print owner */
        req->quename,			/* print queue */
        req->rpriority == -1 ?		/* print priority */
		MAX_RPRIORITY/2 : req->rpriority, /* See ../src/nqs_psc.c */
        req->v.bat.ppnice+20);		/* print nice value */

	/* get cpu seconds */
	if ((req->v.bat.infinite & LIM_PPCPUT) == 0)
		printf(" %-7lu",req->v.bat.ppcputime.max_seconds);
	else
	if ((req->v.bat.explicit & LIM_PPCPUT)
		|| (queue->v.que.type== QUE_BATCH)) 
		printf(" UNLIM. ");
	else
		printf(" UNSPEC.");

	/* get memory */
	/*
	if ((req->v.bat.infinite & LIM_PPMEM) == 0)
		printf(" %-7lu",req->v.bat.ppmemsize.max_quota);
	else
	if ((req->v.bat.explicit & LIM_PPMEM)
		|| (queue->v.que.type== QUE_BATCH)) 
		printf(" UNLIM. ");
	else
		printf(" UNSPEC.");
	*/

	/* get state of request */
	printf(" %-s\n",get_rstate(queue->v.que.type, state));

} /*  end of request */

 
qcmplx_hdr()
{
char hostname[256];

	gethostname(hostname,255);
	hostname[255] = '\0';

        printf("=========================================\n");
        printf(" COMPLEXES for %s\n",hostname);
        printf("=========================================\n");
}                                              


/*** p_req_hdr
 *
 * print header for request 
 */
p_req_hdr(flags)
long flags;
{
char hostname[256];
	printf("===============================================================\n");
	printf("NQS Version: %s ",VERSION);

        if(flags &  SHO_BATCH)
                printf(" BATCH");

        if(flags &  SHO_DEVICE)
                printf(" DEVICE");

        if(flags &  SHO_PIPE)
                printf(" PIPE");

        printf(" REQUESTS on ");
	gethostname(hostname,255);
	hostname[255] = '\0';
	printf("%s \n",hostname);
	

	printf("===============================================================\n");
	printf("REQUEST       NAME            OWNER       QUEUE       PRI NICE CPU     STATE\n");
	/*
	printf("REQUEST       NAME            OWNER    QUEUE    PRI NICE CPU     MEM     STATE\n");
	*/
}


/*** val_user 
 * Determine if selector, the name we are looking for is
 * equal to the name we have 
 */
val_user(selector,name)
char * selector; 
char * name;
{

	if (selector != NULL)	/* This is to allow networking of old NQS */
		if (strcmp(name,selector) == 0)
			return(0);
		else
			return(-1);
}


/*** list
 *
 *
 *	int list():
 *
 *	Print on stdout information about the named object.
 *	Use this to determine if the object is queue, complex, request
 *	or a mistake.
 *	Returns: 0 if output was produced.
 *		-1 if no output was produced.
 */
int list (file, qcomplexfile, name, flags, selector ,qmapfile, pipeqfile)
struct confd *file;			/* NQS queue file */
register struct confd *qcomplexfile;	/*NQS queue complex definition file */
char *name;				/* Name with possible '@' */
long flags;				/* SHO_??? */
char * selector;				/* Name with possible '@' */
register struct confd *qmapfile;	/*NQS qmap definition file */
register struct confd *pipeqfile;	/*NQS qmap definition file */
{

	int whomuid;
	int itsmid;
	short daepresent;
	char	*localname;

	/*   step 1. Override database if daemon not present.  */
#if 	BSD42 | BSD43 | ULTRIX
	daepresent = daepres(file);
#else
#if     SGI | SYS52 | SYS53 | UNICOS | UTS
        daepresent = daepres();
#else    
BAD SYSTEM TYPE
#endif
#endif          

	/* case 1:
	 *	display all queues as no list 
	 *	was sent (name ) and then exit
	 */

	if ((name == NULL) && ! (flags & SHO_CMPLX)){
		if ((flags & SHO_QUE) && ! (flags & SHO_NOHDR) && ! (flags & SHO_FULL))
			qstat_hdr(flags);

		if ((flags & SHO_REQ) && ! (flags & SHO_NOHDR) && ! (flags & SHO_FULL))
			p_req_hdr(flags);
		
		if (search_q(file,name,NULL,flags,selector,daepresent,
				qmapfile,pipeqfile,qcomplexfile) == SUCCESS)
			return(0);
	}

	/* case 2: 
	 *	check to see if the queue is on a remote machine
	 *	if the queue is remote then send it on and return
	 */

	if ((name != NULL))
	  if (check_rmt(name, &itsmid) == SUCCESS) {
		localname = destqueue(name);
		whomuid = getuid();
		if (whomuid == 0)
			printf("Root is not allowed to access other nqs machines via the network for security.\n");
		if (flags & SHO_CMPLX) flags |= SHO_QUE;
		call_host(whomuid,flags,itsmid,localname);
		return(0);
	  }

	/* case 3:
	 *	check to see if name starts with a number
 	 *	if it does then this is a request, else check
	 *	queue
	 */
	if (flags & SHO_REQ ) {
		if ( ! (flags & SHO_NOHDR) && ! (flags & SHO_FULL))
			p_req_hdr(flags);

		if (search_req(file,name,flags,selector,daepresent,qmapfile,
				pipeqfile,qcomplexfile) == SUCCESS)
			return(0);
	}



	/* case 4:
	 *	the list was not remote or a complex, thus check
	 *	for a specific queue if so the queue will be 
	 *	displayed through search_q and then return
	 */

	if ((flags & SHO_QUE) && (name != NULL) && !(flags & SHO_CMPLX)) {
		if ( ! (flags & SHO_NOHDR) && ! (flags & SHO_FULL))
			qstat_hdr(flags);
	}

	if (! (flags & SHO_CMPLX))
	if (search_q(file,name,NULL,flags,selector,daepresent,
			qmapfile,pipeqfile,qcomplexfile) == SUCCESS)
		return(0);

	/* case 4:
	 *	the list was not for a remote machine, 
	 *	thus check to see if the list is a complex
	 *	if it is then the queues in the complex will
	 *	be displayed through search_cmplx() and then return
	 */
	if (search_cmplx(file,qcomplexfile,name,flags,selector,
				daepresent,qmapfile,pipeqfile) == SUCCESS)
		return(0);

	/* case 6:
	 *	was not request, remote, complex or queue
	 *	thus print error message and return
	 */

	printf("%s was not found in the complex or queue list\n");
	return (-1);
	
}


/*** search_cmplx
 * 
 * determine if the object is a complex
 * if it is call search q for each queue in the complex
 */
search_cmplx(file,qcomplexfile,name,flags,selector,daepresent,qmapfile,pipeqfile)
register struct confd *file;            /* MUST be the NQS queue file */
register struct confd *qcomplexfile;	/*NQS queue complex definition file */
char * name;				/* search value  */
register long flags;                    /* Display flags */
register char * selector;               /* account, group, or user list */
register short daepresent;
register struct confd *qmapfile;	/*NQS qmap definition file */
register struct confd *pipeqfile;	/*NQS qmap definition file */
{

	register struct gendescr *descr;
	int i;

	/* display header if this is for show complexes */
	if (flags & SHO_CMPLX)
	 if (! (flags & SHO_NOHDR) )
                qcmplx_hdr();

	/* read first record */
	descr = nextdb(qcomplexfile);	
	if (descr == NULL)
		if ( ! (flags & SHO_QUE ) && ! (flags & SHO_REQ))
			printf("\t\t No complexes on host. \n");

	while (descr != NULL){
	  if (name != NULL)   {
		if (strcmp(descr->v.qcom.name,name)==0) {
			if  (flags & SHO_CMPLX )  { 
				printf("QUEUES for complex %s with run-limit = %d :\n",
					descr->v.qcom.name,descr->v.qcom.runlimit);
 				printf("QUEUE NAME      STATUS   TOTAL   RUNNING  QUEUED   HELD  TRANSITION\n");
				printf("-------------------------------------------------------------------\n");
			}

			for(i=0; i< MAX_QSPERCOMPLX; i++) {
					search_q(file,descr->v.qcom.queues[i]
						,NULL,flags,selector,daepresent,qmapfile,pipeqfile,qcomplexfile);
			}
			return(0);
		}
	  }
	  else 		/* name == NULL, object is not queue or request so print 
			   complex name */
		if (flags & SHO_CMPLX)
			printf("\t %s \n",descr->v.qcom.name);
	descr = nextdb(qcomplexfile);
		
	}
	if (flags & SHO_CMPLX)
		return (0);

	return(-1);

}	/* end of search_cmplx */


/*** search_q
 * 
 * determine if object is a queue
 * and act accordingly
 */
search_q(file,name,req,flags,selector,daepresent,qmapfile,pipeqfile,qcomplexfile)
register struct confd *file;            /* the NQS queue file */
char * name;				/* search value  */
char * req;				/* request value  */
register long flags;                    /* Display flags */
register char * selector;               /* account, group, or user list */
register short daepresent;
register struct confd *qmapfile;            /* the NQS qmap file */
register struct confd *pipeqfile;            /* the NQS pipe file */
struct confd *qcomplexfile;	/*NQS queue complex definition file */
{

	register struct gendescr *descr;

	seekdbb(file,0L);
	descr = nextdb(file);

	while (descr != NULL) {
		if (name != NULL) {	/* print only specific queue */
			if (strcmp(descr->v.que.namev.name,name)==0) {
				if (flags & SHO_QUE) 
						dsp_q(file,descr,flags,
						daepresent,qmapfile,
						pipeqfile,qcomplexfile);
	
				else
					if (flags & SHO_REQ)
						listr(file, descr, flags, 
						    selector,NULL,daepresent);
				return(0);
			}
			descr = nextdb (file);
		}
		else {	/* going to print all queues */
			if (flags & SHO_QUE)  {
					dsp_q(file,descr,flags, daepresent,
						qmapfile,pipeqfile,qcomplexfile);
			}
			else{
				if (flags & SHO_REQ)
					listr(file, descr, flags, selector,
						req,daepresent);
			}
			descr = nextdb (file);
		}
	}
	return(0);
}	/* end of search_q */


/*** shomd
 *
 *
 *      void shomd():
 *      Display an output mode.
 */
static void shomd (mode)
char mode;
{
        if (mode & OMD_SPOOL) {
                printf ("SPOOL");
        }
        else if (mode & OMD_EO) {
                printf ("EO");
        }
        else printf ("NOSPOOL");
}


/*** gunits
 *
 *
 *      char *gunits():
 *      Get quota units.
 */  
static char *gunits (units)
register short units;
{
        switch (units) {
        case QLM_BYTES:
                return ("bytes");
        case QLM_WORDS:
                return ("words");
        case QLM_KBYTES:
                return ("Kbytes");
        case QLM_KWORDS:
                return ("Kwords");
        case QLM_MBYTES:
                return ("Mbytes");
        case QLM_MWORDS:
                return ("Mwords");
        case QLM_GBYTES:
                return ("Gbytes");
        case QLM_GWORDS:
                return ("Gwords");
        }
        return ("");            /* Unknown units! */
 
}     
 

/*** shoquol
 *
 *
 *      void shoquol():
 *      Display a quota limit.
 */
static void shoquol (quota, explicit, infinite, que_descr)
register struct quotalimit *quota;
long explicit;
long infinite;
struct gendescr *que_descr;
{
        if (infinite == 0) {
                printf ("= [%1lu %s, %1lu %s]", quota->max_quota,
                        gunits (quota->max_units), quota->warn_quota,
                        gunits (quota->warn_units));
                if (explicit == 0) printf ("\t<DEFAULT>");
        }
        else {
                /*
                 *  The limit is infinite, or is not specified.
                 */
                if (que_descr->v.que.type == QUE_BATCH || explicit) {
                        printf ("= UNLIMITED ");
                        if (explicit == 0) printf ("\t<DEFAULT>");
                }
                /* Infinite, default limits are meaningless in a pipe queue */
                else printf ("= UNSPECIFIED");
        }
        putchar ('\n');
}  
 
 
/*** shoquetime
 *
 *
 *      void shoquetime():
 *      Display the cumulative cpu time used by requests in a queue.
 *
static void shoquetime (que_descr)
struct gendescr *que_descr;
{
        printf ("  Cumulative system space time = ");
#if     SGI | SYS52 | SYS53 | UNICOS | UTS
        printf ("%ld.%02d seconds\n", que_descr->v.que.ru_stime / CPU_MEAS_GRAN,                ((que_descr->v.que.ru_stime % CPU_MEAS_GRAN) * 100) /
                CPU_MEAS_GRAN);
#else
#if     BSD42 | BSD43 | ULTRIX
        printf ("%ld.%06ld seconds\n", que_descr->v.que.ru_stime,
                que_descr->v.que.ru_stime_usec);
#else
BSD SYSTEM TYPE
#endif
#endif
        printf ("  Cumulative user space time = ");
#if     SGI | SYS52 | SYS53 | UNICOS | UTS
        printf ("%ld.%02d seconds\n", que_descr->v.que.ru_utime / CPU_MEAS_GRAN,                ((que_descr->v.que.ru_utime % CPU_MEAS_GRAN) * 100) /
                CPU_MEAS_GRAN);
#else
#if     BSD42 | BSD43 | ULTRIX
        printf ("%ld.%06ld seconds\n", que_descr->v.que.ru_utime,
                que_descr->v.que.ru_utime_usec);
#else
BSD SYSTEM TYPE
#endif
#endif
}
 */

 
/*** shocpul
 *
 *
 *      void shocpul():
 *      Display a CPU time limit quota.
 */
static void shocpul (cpu, explicit, infinite, que_descr)
register struct cpulimit *cpu;
long explicit;
long infinite;
struct gendescr *que_descr;
{
        if (infinite == 0) {
                printf ("= [%1lu.%1d, %1lu.%1d]",
                         cpu->max_seconds, cpu->max_ms,
                         cpu->warn_seconds, cpu->warn_ms);
                if (explicit == 0) printf ("\t\t<DEFAULT>");
        }
        else {
                /*
                 *  The limit is infinite, or is not specified.
                 */
                if (que_descr->v.que.type == QUE_BATCH || explicit) {
                        printf ("= UNLIMITED ");
                        if (explicit == 0) printf ("\t\t<DEFAULT>");
                }
                else printf ("= UNSPECIFIED");
        }
        putchar ('\n');
}


/*** shoreql
 *
 *
 *      void shoreql():
 *      Display the limits associated with a request.
 */
static void shoreql (que_descr, rawreqp)
struct gendescr *que_descr;             /* Needed to detect pipe queues */
struct rawreq *rawreqp;                 /* The request as a rawreq */
{
        if (que_descr->v.que.type == QUE_PIPE ||
           (VALID_LIMITS & LIM_PPCPUT)) {
                printf ("  Per-proc. CPU time limit      ");
                shocpul (&rawreqp->v.bat.ppcputime,
                           rawreqp->v.bat.explicit & LIM_PPCPUT,
                           rawreqp->v.bat.infinite & LIM_PPCPUT,
                           que_descr);
        }
        if (que_descr->v.que.type == QUE_PIPE ||
           (VALID_LIMITS & LIM_PRCPUT)) {
                printf ("  Per-req. CPU time limit       ");

                shocpul (&rawreqp->v.bat.prcputime,
                           rawreqp->v.bat.explicit & LIM_PRCPUT,
                           rawreqp->v.bat.infinite & LIM_PRCPUT,
                           que_descr);
        }
        if (que_descr->v.que.type == QUE_PIPE ||
           (VALID_LIMITS & LIM_PRDRIVES)) {
                printf ("  Per-req. tape drives limit    ");
                if ((rawreqp->v.bat.infinite & LIM_PRDRIVES) == 0) {
                        printf (" = %1d", rawreqp->v.bat.prdrives);
                        if (!(rawreqp->v.bat.explicit & LIM_PRDRIVES)) {
                                printf ("\t<DEFAULT>");
                        }
                }
                else printf (" = UNSPECIFIED");
                putchar ('\n');
        }
        if (que_descr->v.que.type == QUE_PIPE ||
           (VALID_LIMITS & LIM_PPCORE)) {
                printf ("  Per-proc. core file size limit");
                shoquol (&rawreqp->v.bat.ppcoresize,
                           rawreqp->v.bat.explicit & LIM_PPCORE,
                           rawreqp->v.bat.infinite & LIM_PPCORE,
                           que_descr);
        }
        if (que_descr->v.que.type == QUE_PIPE ||
           (VALID_LIMITS & LIM_PPDATA)) {
                printf ("  Per-proc. data size limit     ");
                shoquol (&rawreqp->v.bat.ppdatasize,
                           rawreqp->v.bat.explicit & LIM_PPDATA,
                           rawreqp->v.bat.infinite & LIM_PPDATA,
                           que_descr);

        }
        if (que_descr->v.que.type == QUE_PIPE ||
           (VALID_LIMITS & LIM_PPPFILE)) {
                printf ("  Per-proc. perm file ");
                printf ("size limit");
                shoquol (&rawreqp->v.bat.pppfilesize,
                           rawreqp->v.bat.explicit & LIM_PPPFILE,
                           rawreqp->v.bat.infinite & LIM_PPPFILE,
                           que_descr);
        }
        if (que_descr->v.que.type == QUE_PIPE ||
           (VALID_LIMITS & LIM_PRPFILE)) {
                printf ("  Per-req. perm file ");
                printf ("space limit");
                shoquol (&rawreqp->v.bat.prpfilespace,
                           rawreqp->v.bat.explicit & LIM_PRPFILE,
                           rawreqp->v.bat.infinite & LIM_PRPFILE,
                           que_descr);
        }
        if (que_descr->v.que.type == QUE_PIPE ||
           (VALID_LIMITS & LIM_PPMEM)) {
                printf ("  Per-proc. memory size limit   ");
                shoquol (&rawreqp->v.bat.ppmemsize,
                           rawreqp->v.bat.explicit & LIM_PPMEM,
                           rawreqp->v.bat.infinite & LIM_PPMEM,
                           que_descr);
        }
        if (que_descr->v.que.type == QUE_PIPE ||
           (VALID_LIMITS & LIM_PRMEM)) {
                printf ("  Per-req. memory size limit   ");
                shoquol (&rawreqp->v.bat.prmemsize,
                           rawreqp->v.bat.explicit & LIM_PRMEM,
                           rawreqp->v.bat.infinite & LIM_PRMEM,
                           que_descr);
        }
        if (que_descr->v.que.type == QUE_PIPE ||
           (VALID_LIMITS & LIM_PRNCPUS)) {
                printf ("  Per-req. # of cpus limit");
                if ((rawreqp->v.bat.infinite & LIM_PRNCPUS) == 0) {
                        printf (" = %1d", rawreqp->v.bat.prncpus);
                        if (!(rawreqp->v.bat.explicit & LIM_PRNCPUS)) {
                                printf ("\t<DEFAULT>");
                        }
                }
                else printf (" = UNSPECIFIED");
                putchar ('\n');
        }
        if (que_descr->v.que.type == QUE_PIPE ||
           (VALID_LIMITS & LIM_PPQFILE)) {
                printf ("  Per-proc. quick file ");
                printf ("size limit");
                shoquol (&rawreqp->v.bat.ppqfilesize,
                           rawreqp->v.bat.explicit & LIM_PPQFILE,
                           rawreqp->v.bat.infinite & LIM_PPQFILE,
                           que_descr);
        }
        if (que_descr->v.que.type == QUE_PIPE ||
           (VALID_LIMITS & LIM_PRQFILE)) {
                printf ("  Per-req. quick file space limit");
                shoquol (&rawreqp->v.bat.prqfilespace,
                           rawreqp->v.bat.explicit & LIM_PRQFILE,
                           rawreqp->v.bat.infinite & LIM_PRQFILE,
                           que_descr);
        }
        if (que_descr->v.que.type == QUE_PIPE ||
           (VALID_LIMITS & LIM_PPSTACK)) {
                printf ("  Per-proc. stack size limit    ");
                shoquol (&rawreqp->v.bat.ppstacksize,
                           rawreqp->v.bat.explicit & LIM_PPSTACK,
                           rawreqp->v.bat.infinite      & LIM_PPSTACK,
                           que_descr);
        }
        if (que_descr->v.que.type == QUE_PIPE ||
           (VALID_LIMITS & LIM_PPTFILE)) {
                printf ("  Per-proc. temp file size limit");
                shoquol (&rawreqp->v.bat.pptfilesize,
                           rawreqp->v.bat.explicit & LIM_PPTFILE,
                           rawreqp->v.bat.infinite & LIM_PPTFILE,
                           que_descr);
        }
        if (que_descr->v.que.type == QUE_PIPE ||
           (VALID_LIMITS & LIM_PRTFILE)) {
                printf ("  Per-req. temp file space limit");
                shoquol (&rawreqp->v.bat.prtfilespace,
                           rawreqp->v.bat.explicit & LIM_PRTFILE,
                           rawreqp->v.bat.infinite & LIM_PRTFILE,
                           que_descr);
        }
        if (que_descr->v.que.type == QUE_PIPE ||
           (VALID_LIMITS & LIM_PPWORK)) {
                printf ("  Per-proc. working set limit   ");
                shoquol (&rawreqp->v.bat.ppworkset,
                           rawreqp->v.bat.explicit & LIM_PPWORK,
                           rawreqp->v.bat.infinite & LIM_PPWORK,
                           que_descr);
        }
        if (que_descr->v.que.type == QUE_PIPE ||
           (VALID_LIMITS & LIM_PPNICE)) {
                printf ("  Per-proc. execution nice pri.");
                if ((rawreqp->v.bat.infinite & LIM_PPNICE) == 0) {
                        printf (" = %1d", rawreqp->v.bat.ppnice +20);
                        if (!(rawreqp->v.bat.explicit & LIM_PPNICE)) {
                                printf ("\t\t\t<DEFAULT>");
                        }
                }
                else printf (" = UNSPECIFIED");

                putchar ('\n');
        }
}


/*** search_req
 * 
 * determine if the object is a request 
 */

search_req(file,name,flags,selector,daepresent,qmapfile,pipeqfile,qcomplexfile) 
register struct confd *file;            /* the NQS queue file */
char * name;				/* search value  */
register long flags;                    /* Display flags */
register char * selector;               /* account, group, or user list */
register short daepresent;
register struct confd *qmapfile;            /* the NQS qmap file */
register struct confd *pipeqfile;            /* the NQS pipeto file */
struct confd *qcomplexfile;	/*NQS queue complex definition file */
{

	/* step 1. 
	 * 	see if name starts with a letter, if
	 *	so then assume it must be a queue 
	 */
	if (isdigit (*name)) { 
		search_q(file,NULL,name,flags,selector,daepresent,qmapfile,pipeqfile,qcomplexfile); 
	}
	else
		return(-1);
}


/*** full_listr
 *
 * list request in full format
 */
full_listr(req,queue,state,flags,selector,def_req,jid)
struct  rawreq  *req;
register struct gendescr *queue;		/* the queue descriptor */
long  state;
long  flags;
char * selector;
char * def_req;
long jid;
{

char * machinename;
char hostname[256];
char type[8];
long val;

	/* if not all validate whom to see */
	if (!(flags & SHO_R_ALLUID)) {
		if (def_req != NULL) {
			val=0;
			while (*def_req >= '0' && *def_req <='9'){
				val *=10;
				val += *def_req -'0';
				def_req++;
			}
			if (val !=req->orig_seqno) 
				return(0);
			
			if (val_user(selector,req->username)== -1)
			{
				printf("invalid administrator at host or did not use administrator option -A or -u\n");
				return(0);
			}
				/* if (adm) */
		}
		else {
			if (val_user(selector,req->username)== -1)
				return (0);
			}
	}

	/* step 2. get host we are on */
	gethostname(hostname,255);
	hostname[255] = '\0';

	/* step 3. get originating host */
	machinename=getmacnam(req->orig_mid);

	/* step 4. determine type of queue */
	if (queue->v.que.type == QUE_BATCH)
		strcpy(type,"BATCH");
	if (queue->v.que.type == QUE_PIPE)
		strcpy(type,"PIPE");
	if (queue->v.que.type == QUE_DEVICE)
		strcpy(type,"DEVICE");

	/* step 5. print header information */
	printf("=====================================================\n");
	printf("NQS version: %s\t%s REQUEST: %d.%s\n",VERSION,type,
		req->orig_seqno,machinename);
	printf("=====================================================\n");

	/* step 6. print name, etc. */
	printf("\tName: %s\t\tOwner: %s\n",req->reqname,req->username);
	printf("\tPriority: %d",queue->v.que.priority);
	printf("\t\tState: %s\n",get_rstate(queue->v.que.type, state));
	printf("\tProcess Family: %-7lu",jid);

	/* step 7. get time */
	if ((state == SHO_RS_HOLD) || (state == SHO_RS_WAIT) || 
			(state== SHO_RS_RUN) )
		printf("\tEligible at: %s\n",fmttime(&req->start_time));
	else
		printf("\tEntered at: %s\n",fmttime(&req->enter_time));
	printf("\t\t\t\tCreated at: %s\n",fmttime(&req->create_time));
	
	/* step 8. get queue */
	printf("\nQUEUE\n");
	printf("\tName: %s@%s\n",req->quename,hostname);

	/* step 9. get resources */
	printf("\nRESOURCES\n");
	shoreql(queue,req);

	/* step 10. get stdout, stderr */
	printf("\nFILES\t\tMODE\t\tNAME\n");
        if ((req->v.bat.stderr_acc & OMD_EO) == 0) {
/*
        	if (req->v.bat.stderr_acc & OMD_M_KEEP) {
                	if (queue->v.que.type == QUE_BATCH) {
                                    machinename = hostname;
                        }
                                else machinename = "<execution-host>";
                 }
                 else {
                                machinename=getmacnam(req->v.bat.stderr_mid);
                 }
*/
                 printf("\tStderr: ");
		 shomd(req->v.bat.stderr_acc);
		 printf("\t%s\n", req->v.bat.stderr_name);
	 }
/*
         if (req->v.bat.stdout_acc & OMD_M_KEEP) {
                 if (queue->v.que.type==QUE_BATCH) {
                                machinename = hostname;
                 }
                 else machinename = "<execution-host>";
                 }
                 else {
                            machinename = getmacnam (req->v.bat.stdout_mid);
         }
*/
        printf ("\tStdout: ");
	shomd (req->v.bat.stdout_acc);
        printf ("\t%s\n", req->v.bat.stdout_name);


	/* step 10. get mail */
	printf("\nMAIL\n");
	printf ("\tAddress: %s@%s\n", req->mail_name,
        getmacnam (req->mail_mid));

	printf ("\tWhen: ");
	if (req->flags & RQF_BEGINMAIL) {
		if (req->flags & RQF_ENDMAIL) 
			printf("begin, end\n");
		else printf ("begin\n");
	}
	else if (req->flags & RQF_ENDMAIL)  {
			printf(" end\n");
	}
	else printf("report of exception condition\n");
 
	/* step 10. get misc */
	printf("\nMISC\n");
	printf("\tRerunnable: "); 

	if (req->flags & RQF_RESTARTABLE)
		printf("yes");
	else printf("no");

	printf("\t\tUser Mask: %d\n",req->v.bat.umask);
	printf("\t\t\t\tOrig. Owner: %s\n",req->username);
        printf ("\tShell: ");
        if (req->v.bat.shell_name [0] == '\0') {
        	printf ("DEFAULT\n");
        }
        else {  /* An explicit shell spec is given */
        	fputs (req->v.bat.shell_name, stdout);
        	putchar ('\n');
        }
	/*
	 * NOT DEFINED AT THIS POINT
 	 *
	 *printf("\nEXPORTED VARIABLES\n");
	 *printf("\t not defined presently\n");
	 *printf("\nARGUMENTS \n");
	 *printf("\t not defined presently\n");
	 */
	printf("\n");
}
