/*++ nextdb.c - Network Queueing System
 *
 * $Source$
 *
 * DESCRIPTION:
 *
 *
 *
 *	Author:
 *	-------
 *	Brent A. Kingsbury, Sterling Software Incorporated.
 *	August 12, 1985.
 *
 *
 * STANDARDS VIOLATIONS:
 *   None.
 *
 * REVISION HISTORY: ($Revision$ $Date$ $State$)
 * $Log$
 *
 */
#include "nqs.h"

extern struct gendescr *readdb();	/* Read descriptor function */

/*** nextdb
 *
 *
 *	struct gendescr *nextdb()
 *
 *	Return a pointer to the next allocated descriptor in the
 *	specified database/configuration file;  If no more allocated
 *	descriptors exist in the specified file, then return NULL.
 */
struct gendescr *nextdb (file)
register struct confd *file;
{
	register struct gendescr *gendescr;
	short zero=0;			/* Used to force signed comparison */

	/*
	 *  Loop to get next generic descriptor from the database file
	 *  ignoring unallocated entries.
	 */
	do {
		gendescr = readdb (file);	/* Get next descriptor */
	} while (gendescr != (struct gendescr *)0 && gendescr->size < zero);
	return (gendescr);
}
