/*++ opendata.c - Network Queueing System
 *
 * $Source$
 *
 * DESCRIPTION:
 *
 *	Open an NQS request data file as called from a server returning
 *	the opened file descriptor number.
 *
 *
 *	Author:
 *	-------
 *	Brent A. Kingsbury, Sterling Software Incorporated.
 *	August 12, 1985.
 *
 *
 * STANDARDS VIOLATIONS:
 *   None.
 *
 * REVISION HISTORY: ($Revision$ $Date$ $State$)
 * $Log$
 *
 */

#include "nqs.h"
#include "nqsxdirs.h"			/* NQS directory definitions */
#if	SGI | SYS52 | SYS53 | UNICOS | UTS
#include <fcntl.h>			/* File control */
#else
#if	BSD42 | BSD43 | ULTRIX
#include <sys/file.h>
#else
BAD SYSTEM TYPE
#endif
#endif

extern void pack6name();		/* Compute name on 6-bit alphabet */

/*** opendata
 *
 *
 *	int opendata():
 *
 *	Open an NQS req data file as called from a server returning
 *	the opened file descriptor number.
 *
 *	Note that the current directory of the caller must be the
 *	NQS root directory (which is the directory at the time that
 *	the server is exec'd from the NQS daemon).
 *
 *	Returns:
 *	      >=0: as the file descriptor of the opened file if
 *		   successful;
 *	       -1: if an error occurs in which case errno is set.
 */
int opendata (orig_seqno, orig_mid, datano)
long orig_seqno;			/* Sequence# for req */
mid_t orig_mid;				/* Machine-id for req */
int datano;				/* Data file number */
{
	char path [MAX_PATHNAME+1];	/* Pathname for data file */

	pack6name (path, Nqs_data, (int) (orig_seqno % MAX_OUTPSUBDIRS),
		  (char *) 0, (long) orig_seqno, 5, (long) orig_mid, 6,
		   datano-1, 3);
	return (open (path, O_RDONLY));
}
