/*++ shoallque.c - Network Queueing System
 *
 * $Source$
 *
 * DESCRIPTION:
 *
 *	Show information about ALL queues on the local machine as
 *	selected by the request selection and display criteria.
 *
 *
 *	Author:
 *	-------
 *	Brent A. Kingsbury, Sterling Software Incorporated.
 *	August 12, 1985.
 *
 *
 * STANDARDS VIOLATIONS:
 *   None.
 *
 * REVISION HISTORY: ($Revision$ $Date$ $State$)
 * $Log$
 *
 */

#include <stdio.h>
#include "nqs.h"

extern struct gendescr *nextdb();	/* Return next allocated entry */
					/* from a database file */
extern int shoqbydesc();			/* Show a queue */

/*** shoallque
 *
 *
 *	int shoallque():
 *	Show status information on ALL of the local NQS queues.
 *
 *	WARNING:
 *		It is assumed that the current position of
 *		the queue definitions file is 0.
 *
 *	Returns:
 *		0: If output was produced.
 *	       -1: If no output was produced.
 *
 */
int shoallque (file, flags, whomuid, reqs, daepresent, qmapfile, pipeqfile,
	qcomplexfile)
register struct confd *file;		/* MUST be the NQS queue file */
register long flags;			/* Display flags */
uid_t whomuid;				/* Whom we are interested in */
register struct reqset *reqs;		/* Req select set */
short daepresent;			/* Boolean non-zero if the local */
					/* NQS daemon is present and running */
struct confd *qmapfile;			/* Queue/device/destination mapping */
					/* file */
struct confd *pipeqfile;		/* Pipe-queue destination file */
struct confd *qcomplexfile;		/* Queue complex definition file */
{
	int result;
	register struct gendescr *descr;

	result = -1;			/* No output produced */
	descr = nextdb (file);
	while (descr != (struct gendescr *)0) {
		if (shoqbydesc (file, descr, flags, whomuid, reqs,
			daepresent, qmapfile, pipeqfile, qcomplexfile) == 0) {
			/*
			 *  Output was produced.
			 */
			result = 0;
			putchar ('\n');	/* Separate queue info by blank line */
		}
		descr = nextdb (file);	/* Get the next queue */
	}
	return (result);
}
