/*++ seekdir.c - 
 *
 * $Source$
 *
 * DESCRIPTION:
 *
 *	Emulate the Berkeley 4.2 UNIX library call of:  seekdir (3x)
 *	On top of the System V fixed name length directory structure.
 *
 *
 *	Author:
 *	-------
 *	Kirk McKusick, University of California, Berkeley.
 *	March 10, 1982.
 *
 *	Modifications:
 *	--------------
 *	Brent A. Kingsbury, Sterling Software Incorporated.
 *	September 10, 1985.
 *
 *	  Changed "#include <dir.h>" to read "#include "dir.4.2.h"" since
 *	  we are after the Berkeley definition, and not System V.
 *
 *
 * STANDARDS VIOLATIONS:
 *
 * REVISION HISTORY: ($Revision$ $Date$ $State$)
 * $Log$
 *
 */

#if	SGI | SYS52 | SYS53 | UNICOS | UTS
#include "dir.4.2.h"
#else
#if	BSD42 | BSD43 | ULTRIX
#include <sys/dir.h>
#else
BAD SYSTEM TYPE
#endif
#endif

/*** seekdir
 *
 *
 *	void seekdir():
 *
 *	Seek to an entry in a directory.
 *	Only values returned by telldir() should be passed to seekdir().
 */
void seekdir(dirp, loc)
register DIR *dirp;
long loc;
{
	long curloc, base, offset;
	struct direct *dp;
	extern long lseek();

	curloc = telldir(dirp);
	if (loc == curloc)
		return;
	base = loc & ~(DIRBLKSIZ - 1);
	offset = loc & (DIRBLKSIZ - 1);
	(void) lseek(dirp->dd_fd, base, 0);
	dirp->dd_loc = 0;
	while (dirp->dd_loc < offset) {
		dp = readdir(dirp);
		if (dp == NULL)
			return;
	}
}
