/*++ telldir.c - 
 *
 * $Source$
 *
 * DESCRIPTION:
 *
 *	Emulate the Berkeley 4.2 UNIX library call of:  telldir (3x)
 *	On top of the System V fixed name length directory structure.
 *
 *
 *	Author:
 *	-------
 *	Kirk McKusick, University of California, Berkeley.
 *	March 10, 1982.
 *
 *	Modifications:
 *	--------------
 *	Brent A. Kingsbury, Sterling Software Incorporated.
 *	September 10, 1985.
 *
 *	  Changed "#include <dir.h>" to read "#include "dir.4.2.h"" since
 *	  we are after the Berkeley definition, and not System V.
 *
 *
 * STANDARDS VIOLATIONS:
 *
 * REVISION HISTORY: ($Revision$ $Date$ $State$)
 * $Log$
 *
 */

#if	SGI | SYS52 | SYS53 | UNICOS | UTS
#include "dir.4.2.h"
#else
#if	BSD42 | BSD43 | ULTRIX
#include <sys/dir.h>
#else
BAD SYSTEM TYPE
#endif
#endif

/*** telldir
 *
 *
 * return a pointer into a directory
 *
 */
long telldir(dirp)
DIR *dirp;
{
	extern long lseek();

	return (lseek(dirp->dd_fd, 0L, 1) - dirp->dd_size + dirp->dd_loc);
}
