/*++ nqs_abort.c - Network Queueing System
 *
 * $Source$
 *
 * DESCRIPTION:
 *
 *	Abort NQS daemon execution.
 *
 *
 *	Author:
 *	-------
 *	Brent A. Kingsbury, Sterling Software Incorporated.
 *	August 12, 1985.
 *
 *
 * STANDARDS VIOLATIONS:
 *   None.
 *
 * REVISION HISTORY: ($Revision$ $Date$ $State$)
 * $Log$
 *
 */

#include <stdio.h>
#include "nqs.h"
#include "nqsxvars.h"			/* NQS global vars */

extern char *asciierrno();		/* Return ASCII version of errno */
extern int errno;			/* System call error number */

/*** nqs_abort
 *
 *
 *	void nqs_abort():
 *
 *	Abort execution of the NQS daemon writing a message to
 *	the NQS log process.
 */
void nqs_abort ()
{
	if (errno) printf ("I$%s.\n", asciierrno());
	printf ("I$Execution aborted.\n");
	fflush (stdout);
	exit (1);
}
